// fluid_project/CDrawBox.cpp

#include "CDrawBox.h"

CPrimitiveBase* create_primitive(
    int type,
    int x1,
    int y1,
    int x2,
    int y2,
    Fl_Color color
    )
{
    switch ( type ) {
    case BTN_RADIO_ID_LINE:
        return new CPrimitiveLine( x1, y1, x2, y2, color );

    case BTN_RADIO_ID_CIRCLE:
        return new CPrimitiveCircle( x1, y1, x2, y2, color );

    case BTN_RADIO_ID_RECTANGLE:
        return new CPrimitiveRectangle( x1, y1, x2, y2, color );
    default:
        assert( !"BAD button id in CMainWindow::click_radio_button()" );
        return nullptr;
    }
}

