// Lab 15: Scratch Pad App
// CMainWindow.cpp

#include "CMainWindow.h"

void CMainWindow::show()
{
    // Window callbacks:
    win_app->callback( (Fl_Callback*)CMainWindow::callback_window_closing, (void*)(this) );
    rdo_line->callback( (Fl_Callback*)CMainWindow::callback_radio_button, (void*)( new CRadioSelector(this, BTN_RADIO_ID_LINE ) ) );
    rdo_circle->callback( (Fl_Callback*)CMainWindow::callback_radio_button, (void*)( new CRadioSelector(this, BTN_RADIO_ID_CIRCLE ) ) );
    rdo_rectangle->callback( (Fl_Callback*)CMainWindow::callback_radio_button, (void*)( new CRadioSelector(this, BTN_RADIO_ID_RECTANGLE ) ) );
    chk_filled->callback( (Fl_Callback*)CMainWindow::callback_check_button, (void*)(this) );

    rdo_line->value( 1 ); // make sure line primitive is selected by default
    chk_filled->deactivate();
    draw_box->use_primitive_type( BTN_RADIO_ID_LINE );

    // Make the window visible:
    win_app->show();
}

// callback functions
void CMainWindow::callback_window_closing(Fl_Widget* widg, void* userdata_) {
    std::cout << "X button clicked -- exiting the program\n";
    while( Fl::first_window() ) {
        Fl::first_window()->hide();
    }
}

void CMainWindow::click_radio_button( int button_id )
{
    std::cout << "radio click " << button_id << "\n";
    draw_box->use_primitive_type( button_id );
    switch ( button_id ) {
    case BTN_RADIO_ID_LINE:
        chk_filled->deactivate();
        break;

    case BTN_RADIO_ID_CIRCLE:
        chk_filled->activate();
        break;

    case BTN_RADIO_ID_RECTANGLE:
        chk_filled->activate();
        break;
    default:
        assert( !"BAD button id in CMainWindow::click_radio_button()" );
    }

}

void CMainWindow::callback_radio_button(Fl_Widget* widg, void* userdata_ )
{
    CRadioSelector* selector = static_cast< CRadioSelector* >( userdata_ );
    selector->select();
}

CRadioSelector::CRadioSelector( CMainWindow* window, int button_id )
    :
window( window ), button_id( button_id )
{
}

void CRadioSelector::select()
{
    window->click_radio_button( button_id );
}

void CMainWindow::click_check_button()
{
    std::cout << "check box click: " << int( chk_filled->value() ) << "\n";
}

void CMainWindow::callback_check_button(Fl_Widget* widg, void* userdata_)
{
    CMainWindow* window = static_cast< CMainWindow* > ( userdata_ );
    window->click_check_button();
}
